"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformLessToCssVariable = void 0;
const postcss_1 = __importDefault(require("postcss"));
const syntax = __importStar(require("postcss-less"));
const fs_extra_1 = require("fs-extra");
const transformPlugin = ({ resolveRoot, atRules, decls, }) => {
    return {
        postcssPlugin: 'transformLessToCssVariablePlugin',
        Root(root) {
            resolveRoot === null || resolveRoot === void 0 ? void 0 : resolveRoot(root);
        },
        AtRule(atRule, helper) {
            return __awaiter(this, void 0, void 0, function* () {
                if (atRules) {
                    Promise.all(atRules.map((fn) => fn(atRule, helper)));
                }
            });
        },
        Declaration(decl, helper) {
            if (decls) {
                Promise.all(decls.map((fn) => fn(decl, helper)));
            }
        },
    };
};
const transformLessToCssVariable = (filePath, options) => __awaiter(void 0, void 0, void 0, function* () {
    if (!(0, fs_extra_1.existsSync)(filePath)) {
        throw new Error(`[transformLessToCssVariable] ${filePath} file does not exist.`);
    }
    const fileContent = (yield (0, fs_extra_1.readFile)(filePath)).toString('utf-8');
    return (0, postcss_1.default)([transformPlugin(options)])
        .process(fileContent, { syntax, from: filePath })
        .then((result) => { var _a, _b; return (_b = (_a = options.formatResult) === null || _a === void 0 ? void 0 : _a.call(options, result)) !== null && _b !== void 0 ? _b : result; })
        .catch((e) => console.log('postcss error', e));
});
exports.transformLessToCssVariable = transformLessToCssVariable;
