"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runReductions = void 0;
const fs_extra_1 = require("fs-extra");
const utils_1 = require("./utils");
// 还原
const reduction = (ruleOption, options) => __awaiter(void 0, void 0, void 0, function* () {
    const { joinFullPath } = options;
    // 获取真实的备份 less 文件路径
    const backupStyleFilePath = (0, utils_1.getBackupFilePath)(ruleOption.styleFilePath);
    const realStyleFilePathByNorm = joinFullPath(ruleOption.styleFilePath);
    const backupFilePath = joinFullPath(backupStyleFilePath);
    if (!(0, fs_extra_1.existsSync)(backupFilePath)) {
        return Promise.resolve();
    }
    // 复制覆盖
    yield (0, fs_extra_1.copyFile)(backupFilePath, realStyleFilePathByNorm);
    return (0, fs_extra_1.remove)(backupFilePath);
});
// 批量还原
const runReductions = (replaceVariableRules, options) => {
    return Promise.all(replaceVariableRules.map((item) => reduction(item, options)));
};
exports.runReductions = runReductions;
