"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateVariables = exports.generate = void 0;
const less_variables_1 = __importStar(require("./less-variables"));
const util_1 = require("./util");
const util = __importStar(require("./util"));
const colors_1 = require("@ant-design/colors");
function generate(options = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const { selector = ':root', color, manualVariables = [] } = options;
        mergeConvertedVariables(manualVariables);
        if (typeof color === 'string') {
            options.color = {
                primary: color,
            };
        }
        const variables = yield generateVariables(options);
        let cssText = ``;
        Object.keys(variables).forEach((key) => {
            cssText += `\t${key}: ${variables[key]};\n`;
        });
        const dom = typeof selector === 'string'
            ? document && document.querySelector(selector)
            : selector;
        if (dom) {
            dom.style.cssText = dom.style.cssText + cssText;
        }
        return { variables, cssText };
    });
}
exports.generate = generate;
function generateVariables(options = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const generateColor = yield generateColors(options);
        Object.assign(less_variables_1.default, generateColor, options.variables || {});
        const result = less_variables_1.convertedVariables;
        yield Promise.all(Object.keys(less_variables_1.unCoverVariable).map((key) => __awaiter(this, void 0, void 0, function* () {
            const ret = (0, util_1.getVarNameAndFunc)(key);
            if (ret) {
                const { varName, funcName, varNumber } = ret;
                const color = less_variables_1.default[varName] || result[`--${varName}`];
                if (color) {
                    const newColor = util[funcName](color, varNumber);
                    less_variables_1.default[key] = newColor;
                }
            }
        })));
        // // 转化需要计算的颜色
        // Object.keys(unCoverVariable).forEach((key) => {
        //   const ret = getVarNameAndFunc(key);
        //   if (ret) {
        //     const { varName, funcName, varNumber } = ret;
        //     const color = cssVariables[varName] || result[`--${varName}`];
        //     if (color) {
        //       const newColor = util[funcName](color, varNumber);
        //       cssVariables[key] = newColor;
        //     }
        //   }
        // });
        // 转成 var类型
        Object.keys(less_variables_1.default).forEach((key) => {
            result[`--${key}`] = less_variables_1.default[key];
        });
        return result;
    });
}
exports.generateVariables = generateVariables;
function generateColors(options = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const { color = {} } = options;
        const result = {};
        // 第5个主色
        const mainIndex = 5;
        const alias = {
            primary: 'blue',
            success: 'green',
            error: 'red',
            warning: 'gold',
        };
        Object.keys(color).forEach((key) => {
            if (color[key]) {
                const colors = (0, colors_1.generate)(color[key]);
                result[`${key}-color`] = colors[mainIndex];
                const getValue = (item, index) => index === mainIndex ? `var(--${key}-color)` : item;
                colors.forEach((item, index) => {
                    result[`${alias[key]}-${index + 1}`] = getValue(item, index);
                });
                if (key === 'primary') {
                    colors.forEach((item, index) => {
                        result[`primary-${index + 1}`] = getValue(item, index);
                    });
                }
            }
        });
        return result;
    });
}
function mergeConvertedVariables(variables = []) {
    const obj = {};
    variables.forEach((key) => {
        obj[key] = util_1.__ANT_DESIGN_FUNCTION_TOKEN__;
    });
    Object.assign(less_variables_1.unCoverVariable, obj);
}
exports.default = { generate };
